DptPjg proto :dword,:dword
DptLarikInd proto :dword,:dword,:dword
Hapus proto :dword,:dword
TmbStr proto :dword,:dword
BndStr proto :dword,:dword,:dword
CariCh proto :dword,:byte
DptFile proto :dword,:dword,:dword
IsAlNum proto :byte
b2bin proto :byte,:dword
IgnChar proto :dword,:byte
CariChMundur proto :dword,:byte,:dword
htod proto :dword
shtod proto :dword
atod proto :dword
btod proto :dword

GetTextIndex  proto :dword,:dword,:dword,:dword,:dword
GetTextIndex2 proto :dword,:dword,:dword,:dword,:dword,:dword
GetOffsetIndex proto :dword,:dword,:dword

LineCheck proto :dword,:dword
LineCount proto :dword,:dword
LineLength proto :dword,:dword
CopyDW proto :dword,:dword,:dword

CreateOffsetTable proto :dword,:dword,:dword,:dword
GetOffsetTable proto :dword,:dword,:dword
GetTextTable proto :dword,:dword,:dword,:dword,:dword

CharToDW proto :dword,:dword

.code

CharToDW proc lptz:dword,base:dword
	
	pop edx			; 1-byte EIP
	pop ecx			; 1-byte base
	pop esi			; 1-byte lptz
		push edx	; 1-byte EIP
	xor edx,edx		; 2-byte
	
	dloop:
	mov al,[esi]
	cmp al,'A'
	jae it_hex_lch
	cmp al,'a'
	jae it_hex_uch
	cmp al,'0'
	jae it_num
	cmp al,0
	jz done
	cmp al,13
	jz done
		; error
		xor ecx,ecx
		dec ecx
		ret
it_hex_lch:
	sub al,'a'
	add al,10
	jmp keep
it_hex_uch:
	sub al,'A'
	add al,10
	jmp keep
it_num:
	and al,0fh
keep:
	mul cl
	add edx,eax
	xor ecx,ecx
	inc esi
	inc ch
	jmp dloop

done:
	ret
CharToDW endp	; edx:hiDword,eax:loDword,ecx:status

CreateOffsetTable proc uses esi edi  lpSou:dword,lpTbl:dword,FileSize:dword,lnCnt:dword
	;LOCAL rslt,Pos:dword
	
	
	mov esi,lpSou
	mov edi,lpTbl
		
	xor ecx,ecx
		mov [edi],ecx
		add edi,4
	dloop:
	mov dl,[esi]
		inc ecx
	cmp dl,10
	jnz go
		inc eax
		mov [edi],ecx
		add edi,4
	go:
	inc esi
	cmp ecx,FileSize
	jl dloop
	
	
	ret
CreateOffsetTable endp

GetOffsetTable proc uses esi edi nPos:dword,lpTbl:dword,nMaxPos:dword
	
	mov esi,lpTbl
	mov ecx,nPos
	mov edx,nMaxPos
	
	cmp ecx,edx
	ja brs
		xor eax,eax
		cmp ecx,eax
		jle brs
			dec ecx
			mov eax,[esi+ecx*4]
			ret
	brs:
		xor eax,eax
		dec eax
	ret
GetOffsetTable endp

GetTextTable proc uses esi edi nPos:dword,lpTbl:dword,nMaxPos:dword,lpDest:dword,lpSou:dword
	
	invoke GetOffsetTable,nPos,lpTbl,nMaxPos
	cmp eax,-1
	jz brs
	
	mov esi,lpSou
	mov edi,lpDest
	add edi,eax
	xor ecx,ecx
		mloop:
		inc ecx
		lodsb
		stosb
				cmp al,0
				jz __done
				cmp al,9
				jz mloop
				cmp al,';'
				jz __done
			cmp al,13
			jnz mloop
	__done:
		dec edi
	mov byte ptr[edi],0
	xchg eax,ecx
	
	brs:
	ret
GetTextTable endp

RemoveChar proc uses esi edi lptz:dword,char:byte
	LOCAL Bupp[1024]:dword		; max Char are 4096
	
	mov esi,lptz
	lea edi,Bupp
	
	xor ecx,ecx
	xor edx,edx
	deloop:
	mov al,[esi+edx]
	inc edx
		cmp al,char
		jz deloop
		cmp al,0
		jz brs
	mov [edi+ecx],al
	inc edi
	inc ecx
	jmp deloop
	
	xchg esi,edi
	rep movsb
	
	brs:
	ret
RemoveChar endp


GetOffsetIndex proc uses esi Pos:dword,lpSource:dword,FileSize:dword	; <<Slow causes
	
	xor eax,eax
	cmp Pos,eax
	jnz go
		inc Pos
	go:
	inc eax
	cmp Pos,eax
	jnz go2
		xor eax,eax
		jmp brs
	go2:
	
	mov esi,lpSource
	xor edx,edx
	inc edx
	xor ecx,ecx
	mloop:
	inc ecx
	mov al,[esi]
	cmp al,10
	jnz go3
		inc edx
	go3:
	;.if al==10
	;	inc edx		
	;.endif
	cmp Pos,edx
	jnz go4
		mov eax,ecx
		mov ecx,esi
		jmp brs
	go4:
;	.if edx==Pos
;		mov eax,ecx
;		mov ecx,esi
;		jmp brs
;	.endif
	
	inc esi
	cmp ecx,FileSize
	jl mloop
	
	xor eax,eax
	dec eax
	
	brs:
	ret
GetOffsetIndex endp

GetTextIndex proc uses esi edi ebx Pos:dword,lpSource:dword,lpDest:dword,FileSize:dword,LnCnt:dword
		
	mov eax,LnCnt
	cmp Pos,eax
	jl go
		xor eax,eax
		dec eax
		jmp brs
	go:
	
	invoke GetOffsetIndex,Pos,lpSource,FileSize
	cmp eax,-1
	jnz go2
		jmp brs
	go2:
	
	mov edi,lpDest
	mov esi,lpSource
	add esi,eax
	
	invoke LineLength,esi,FileSize
	cmp eax,-1
	jnz go3
	jmp brs
	go3:
	
	push esi
	dec eax
	add esi,eax
	mov byte ptr[esi],0
	inc eax
	pop esi
	
	push esi
	push eax
	
	mov ecx,FileSize
	erase_tab_loop:
	mov al,[esi]
	cmp al,9
	jnz go4
		mov byte ptr[esi],' '			; If we Found 9(Tab) change it to space
	go4:
	inc esi
	dec ecx
	jnz erase_tab_loop					; loop until ecx=zero
	
	pop eax
	pop esi
	
	pushad
	mov ecx,eax
	mov edx,eax
	mov_data_b:
		mov al,[esi]
		inc esi
		mov [edi],al
		inc edi
		dec ecx
		jnz mov_data_b
	popad
	
	
	brs:
	ret
GetTextIndex endp

GetTextIndex2 proc uses esi edi ebx Pos:dword,lpSource:dword,lpTbl:dword,lpDest:dword,FileSize:dword,LnCnt:dword
		
	mov eax,LnCnt
	cmp Pos,eax
	jl go
		xor eax,eax
		dec eax
		jmp brs
	go:
	
	invoke GetOffsetTable,Pos,lpTbl,LnCnt
	cmp eax,-1
	jnz go2
		jmp brs
	go2:
	
	mov edi,lpDest
	mov esi,lpSource
	add esi,eax
	
	invoke LineLength,esi,FileSize
	cmp eax,-1
	jnz go3
	jmp brs
	go3:
	
	push esi
	dec eax
	add esi,eax
	mov byte ptr[esi],0
	inc eax
	pop esi
	
	push esi
	push eax
	
	mov ecx,FileSize
	erase_tab_loop:
	mov al,[esi]
	cmp al,9
	jnz go4
		mov byte ptr[esi],' '			; If we Found 9(Tab) change it to space
	go4:
	inc esi
	dec ecx
	jnz erase_tab_loop					; loop until ecx=zero
	
	pop eax
	pop esi
	
	pushad
	mov ecx,eax
	mov edx,eax
	mov_data_b:
		mov al,[esi]
		inc esi
		mov [edi],al
		inc edi
		dec ecx
		jnz mov_data_b
	popad
	
	
	brs:
	ret
GetTextIndex2 endp


LineLength proc uses esi lpHrp:dword,FileSize:dword
	
	mov esi,lpHrp
	xor ecx,ecx
	mloop:
	inc ecx
	mov al,[esi]
	inc esi
	cmp al,13
	jnz go
		mov eax,ecx
		jmp brs
	go:
	cmp al,0
	jnz go2
		mov eax,ecx
		jmp brs
	go2:
	;.if al==13		
	;	mov eax,ecx
	;	jmp brs
	;.elseif al==0
	;	mov eax,ecx
	;	jmp brs
	;.endif
	cmp ecx,FileSize
	jl mloop
	xor eax,eax
	dec eax
	
	brs:
	ret
LineLength endp

LineCount proc uses esi edi lpTheFile:dword,FileSize:dword
	
	mov esi,lpTheFile

	
	xor ecx,ecx
	xor eax,eax
	inc eax
	inc eax
	
	dloop:
	mov dl,[esi]
	cmp dl,13
	jnz @f
		inc eax
	@@:
	inc esi
	inc ecx
	cmp ecx,FileSize
	jl dloop
	
	
	ret
LineCount endp

CopyDW proc uses esi edi destination:dword,source:dword,count:dword
	
	
	mov esi,source
	mov edi,destination	
	xor ecx,ecx
	dlp:	
	;mov al,[esi]
	;mov [edi],al
	;stosb
	;inc esi
	;inc edi
	movsb
	inc ecx
	cmp ecx,count
	jl dlp	
	
	ret
CopyDW endp

LineCheck proc uses esi edi lpal:dword,count:dword
	LOCAL Bupp[256]:dword
	
		
	invoke IgnChar,lpal,' '
	mov esi,eax
	sub eax,lpal
	sub count,eax
	
	invoke CopyDW,addr Bupp,esi,count
	invoke Hapus,lpal,count
	
	invoke CariCh,addr Bupp,';'
	.if eax!=-1
		dec eax
		mov count,eax
	.endif
	
	invoke CariCh,lpal,';'
	mov esi,lpal
	dec eax
	add esi,eax
	mov byte ptr[esi],0
	
	brs:
	invoke CopyDW,lpal,addr Bupp,count
	mov eax,count
	
	brs2:
	ret
LineCheck endp

btod proc uses esi edi lpHrp:dword
	
	xor edx,edx
	xor ecx,ecx
	xor eax,eax
	mov esi,lpHrp
	
	aloop:
	mov dl,byte ptr[esi+ecx]
	
	test dl,dl 		;I dont know
	jz aexit
	
	cmp dl,' '
	jz aexit
	cmp dl,0dh
	jz aexit
	cmp dl,30h
	jl error
	cmp dl,31h
	ja error
	
	push ebx
	
	mov ebx,2
	sub dl,30h
	mul bl
	add eax,edx
	
	pop ebx
	
	inc ecx
	jmp aloop
	
	error:
	xor eax,eax
	dec eax
	
	aexit:
	ret
btod endp

atod proc uses esi edi lpHrp:dword
	LOCAL Result:dword
	
	xor edx,edx			; This code was not Mine.
	xor ecx,ecx			; Announce everyone on board.Win32asmCommunity.net
	xor eax,eax
	mov esi,lpHrp
	
	aloop:
	mov dl,byte ptr[esi+ecx]
	
	test dl,dl 		;I dont know
	jz aexit
	
	cmp dl,' '
	jz aexit
	cmp dl,0dh
	jz aexit
	cmp dl,30h
	jl error
	cmp dl,39h
	ja error
	
	push ebx
	
	mov ebx,10
	sub dl,30h
	mul bl
	add eax,edx
	
	pop ebx
	
	inc ecx
	jmp aloop
	
	error:
	xor eax,eax
	dec eax
	mov ecx,eax
	aexit:
	ret
atod endp

shtod proc uses esi edi lpHrp:dword
	
	mov esi,lpHrp
	mov al,[esi]		
		
		.if AL=='-'
			inc esi
			invoke htod,esi
			pros:
			push ecx
				xor ecx,ecx
				dec ecx
				sub ecx,eax
				inc ecx
				xchg ecx,eax
				xor ecx,ecx
			pop ecx
		.elseif al=='#'
			inc esi
			mov al,[esi]
			.if al=='-'
				inc esi
				invoke atod,esi
				jmp pros
			.elseif al=='B'
				inc esi
				invoke btod,esi				
			.else
				invoke atod,esi
			.endif
		.elseif al==27h
			inc esi
			mov eax,[esi]
			bswap eax
		.else			
			invoke htod,esi
		.endif
		
		
	brs:
	ret
shtod endp 

htod proc uses ecx edx esi hexstr:DWORD
; code taken from RoticV disasembler package.
xor eax, eax
xor ecx, ecx
xor edx, edx
mov esi, hexstr
hexloop:
mov dl, byte ptr [esi+ecx]

test dl, dl
jz hexit ; success

cmp dl,' '
jz hexit
cmp dl,':'
jz hexit
cmp dl,0dh
jz hexit
cmp dl, 30h
jl error
cmp dl, 39h
jle number
cmp dl, 40h
jle error
cmp dl, 46h
jle letter
cmp dl, 60h
jle error
cmp dl, 66h
jle letter

error: 	xor eax,eax
		dec eax
		mov ecx,eax
hexit: ret

letter: sub dl, 7
number: and dl, 0Fh

shl eax, 4
jc error ;overflow

or eax, edx
inc ecx
jmp hexloop
ret
htod endp

CariChMundur proc uses esi edi PointerHrp:dword,HrpYangDicari:byte,BatasPencarian:dword
	
	mov esi,PointerHrp
	mov ecx,BatasPencarian
	inc ecx
	xor edx,edx
	mov ah,HrpYangDicari
	
	deloop:
	inc edx
	mov al,[esi]
	cmp edx,ecx
	jz Tidak_Ditemukan
	dec esi
	cmp al,ah
	jnz deloop
	Tidak_Ditemukan:
	mov eax,-1
	brs:
	inc esi
	mov eax,esi
	
	
	ret
CariChMundur endp

IgnChar proc uses esi lpHrp:dword,char:byte
	
			
	mov esi,lpHrp
	hpsSpc:
	mov al,[esi]		
	inc esi
	.if al==0
		jmp brs
	.elseif al==13
		jmp brs
	.endif
	cmp al,char
	jz hpsSpc
	cmp al,09h
	jz hpsSpc
	dec esi
	
	brs:
	mov eax,esi
	
	ret
IgnChar endp


b2bin proc uses esi edi nil:byte,lpHrp:dword
	LOCAL rmnd,Bupp[9]:byte
	
	mov rmnd,0
	mov al,nil
	and eax,0ffh
	lea esi, Bupp
	mov edi,lpHrp
	deloop:
	mov cl,al
	and cl,1
	cmp cl,1
	jnz trs
	mov byte ptr[esi],'1'
	jmp lnjt
	trs:
	mov byte ptr[esi],'0'
	lnjt:
	ror al,1
	inc esi
	inc rmnd
	cmp rmnd,8
	jl deloop
	
	lea esi, Bupp
	mov edi,lpHrp
	add edi,7
	xor ecx,ecx
	
	deloop2:
	inc cx
	mov al,byte ptr[esi]
	mov byte ptr[edi],al
	inc esi
	dec edi
	cmp cx,8
	jl deloop2
	
	
	mov byte ptr[esi],0
	
	ret
b2bin endp

IsAlNum proc chr:byte
	
	xor eax,eax
	cmp chr,20H
	jl klr
	cmp chr,7eH
	ja klr
	inc al
	klr:
	
	ret
IsAlNum endp

DptFile proc uses ebx esi lpAlm:dword,lpAlm2:dword,lpAlm3:dword
	LOCAL Bupp[128]:byte,pjg,alm:dword

	mov pjg,0
	push lpAlm
	pop alm
	mloop:
	invoke CariCh,lpAlm,'\'
	cmp eax,-1
	jz klr
	add lpAlm,eax
	inc pjg
	jmp mloop
	klr:
	mov esi,lpAlm
	mov ebx,lpAlm2	
	deloop:
	inc ecx
	mov al,byte ptr [esi]
	cmp al,010h
	jl klr2
	mov byte ptr [ebx],al
	inc esi
	inc ebx
	jmp deloop
	klr2:
	mov byte ptr[ebx],0
	
	mov esi,alm
	mov ebx,lpAlm3
	deloop2:
	mov al,byte ptr [esi]
	mov byte ptr [ebx],al
	inc esi
	inc ebx
	cmp esi,lpAlm
	jl deloop2
	dec ebx
	mov byte ptr[ebx],0
	
	
	ret
DptFile endp

CariCh proc uses esi lpAlm:dword,k:byte

	
;	mov esi,lpAlm
;	xor ecx,ecx
;	delopp:
;	inc ecx
;	mov al,[esi]
;	inc esi
;		
;	.if al==k
;		xchg eax,ecx
;		ret
;	.elseif al==13
;		
;	.elseif al==0
;		
;	.else
;		jmp delopp
;	.endif	
	
;	ggl:
;	xor eax,eax
;	dec eax
	mov edx,lpAlm				; BitRake
	xor ecx,ecx
delopp:
	mov al,[edx]
	inc edx
	inc ecx

	cmp al, k
	je __k
	cmp al, 13
	je __CR
	cmp al, 0
	jne delopp
__CR:
	xor eax,eax
	dec eax
	ret
__k:
	xchg eax,ecx

	
	
	ret
CariCh endp

BndStr proc uses esi edi lpAlm:dword,lpAlm2:dword,Len:dword
	
	;xor eax,eax				<< Size optimized, But Real Slow.
	;
	;mov esi,lpAlm
	;mov edi,lpAlm2
	;mov ecx,Len
	;
	;repe cmpsb	
	;jnz lbng
	;inc eax
	;lbng: 
	
	cld
	xor eax,eax					; << Speed & size raise Up
	
	mov esi,lpAlm
	mov edi,lpAlm2
	mov ecx,Len
		shr ecx,2
		jz it_only_Byte
	repe cmpsd	
	jnz lbng
		mov ecx,Len
		and ecx,3
		jnz trs
	inc eax
	ret
	trs:
		repe cmpsb			; 8
		jnz lbng
		inc eax
		ret
	it_only_Byte:
		mov ecx,Len
		jmp trs
	lbng: 
	

	
	ret
BndStr endp

Hapus proc uses esi alm:dword,cou:dword
	
	;xor ecx,ecx
	;mov esi,alm
	;dloop:
	;inc ecx
	;mov byte ptr[esi],0
	;inc esi
	;cmp ecx,cou
	;jl dloop
	
	mov ecx,cou
	mov edi,alm
	xor eax,eax
	
	shr ecx,2
	rep stosd
		mov ecx,cou
		and ecx,3
		rep stosb
	
	ret
Hapus endp

DptPjg proc uses esi edi Source:dword,Destination:dword
	LOCAL hit:dword,lpalm:dword
	
	mov esi,Source
	mov hit,0
	mov edi,Destination
		
	deloop:
	mov al,byte ptr[esi]
	cmp al,9
	jnz Keep_go
		mov ah,' '
	Keep_go:
	cmp al,0
	jnz Keep_go2
		jmp trs
	Keep_go2:
	;.if al==09h
	;	mov ah,' '
	;.elseif al==0
	;	jmp trs
	;.endif
	
	mov [edi],al
	inc hit
	inc edi
	inc esi
	cmp al,10h
	jae deloop
	mov byte ptr[edi],0 
	dec hit	
	
	trs:				        
    mov eax,hit
      		
	ret
DptPjg endp

LarikInd proc uses esi edi lpHrp:dword,hrp:dword,pos:dword
	LOCAL poss:dword,jml:dword
	
	xor eax,eax
	xor ecx,ecx
	cmp pos,0
	jz klr

	mov poss,0
	deloop:
	invoke DptPjg,lpHrp,hrp
	mov jml,eax		
	add lpHrp,eax
	add lpHrp,2
	inc poss
	mov eax,poss
	cmp eax,pos
	jl deloop
	
	mov eax,jml
	klr:
	
	ret
LarikInd endp


